//=========================================================================
//	CSceneMeshクラス [ sceneMesh.h ]
//	作成日：2017/05/02
//	作成者：小暮大樹
//=========================================================================
//インクルードガード
#pragma once

//=========================================================================
//	インクルードファイル
//=========================================================================
#include	"scene.h"
#include	"scene3D.h"

//=========================================================================
//	CScene3Dクラス
//=========================================================================
class	CSceneMesh3D : public CScene3D
{
public:
	CSceneMesh3D( int sheetTate , int sheetYoko , D3DXVECTOR3 Size );	// コンストラクタ
	~CSceneMesh3D();			// デストラクタ
	void Init( void );		// 初期化処理
	void Uninit( void );	// 終了処理
	void Update( void );	// 更新処理
	void Draw( void );		// 描画処理

	//設定関数
	void	SetSheet		( const	float yoko , const float tate )	{ m_Sheet.x = yoko; m_Sheet.y = 0; m_Sheet.z = tate; };				//縦横枚数の設定
	void	SetPolygonNum	( const unsigned int& polygonNum )		{ m_nPolygonNum = polygonNum; };	//
	void	SetStartPos		( const D3DXVECTOR3& startPos )			{ m_StartPos = startPos; };
	void	SetNumVertex	( const unsigned int& numVertex  )		{ m_nNumVertex = numVertex; };
	void	SetNumIndex		( const	unsigned int& numIndex )		{ m_nNumIndex = numIndex; };

	//取得関数
	const	D3DXVECTOR3&	GetSheet( void )		const { return m_Sheet; };
	const	unsigned int&	GetPolygonNum( void )	const { return m_nPolygonNum; };
	const	D3DXVECTOR3&	GetStartPos( void )		const { return m_StartPos; };
	const	unsigned int&	GetNumVertex( void )	const { return m_nNumVertex; };
	const	unsigned int&	GetNumIndex( void )		const { return m_nNumIndex; };

private:
	HRESULT	MakeVertex( LPDIRECT3DDEVICE9 pDevice );

//	D3DXMATRIX m_mtxWorld;			// ワールドマトリックス
	D3DXVECTOR3		m_Sheet;		//ポリゴンの枚数
	D3DXVECTOR3		m_StartPos;		//中心座標から割り出した始点の場所
	unsigned int	m_nNumVertex;	//頂点数
	unsigned int	m_nPolygonNum;	//ポリゴン数
	unsigned int	m_nNumIndex;	//インデックス数

	LPDIRECT3DINDEXBUFFER9	m_pIndexBuffer;
};
